/* $Id$ */
#ifndef __COMMON_H__
#define __COMMON_H__
#include "h83048addr.h"

typedef unsigned char byte;

extern volatile byte p1_ddr;
extern volatile byte p2_ddr;
extern volatile byte p3_ddr;
extern volatile byte p4_ddr;
extern volatile byte p5_ddr;
extern volatile byte p6_ddr;
extern volatile byte p8_ddr;
extern volatile byte p9_ddr;
extern volatile byte pa_ddr;
extern volatile byte pb_ddr;

extern volatile long systicks; // 1 msec counter

#define MCLOCK	16	// 16 MHz

#define BUFSIZE	32	// must be 2^n

struct buffer {
	byte buf[BUFSIZE];
	int put_ptr;
	int get_ptr;
};

#define buffer_exist(b)	((b)->put_ptr != (b)->get_ptr)
#define buffer_full(b)	((((b)->put_ptr+1)&(BUFSIZE-1)) == (b)->get_ptr )

extern volatile struct buffer kbd_recv_data;
extern volatile int kbd_sending;
extern volatile int kbd_send_cnt;
extern volatile int kbd_recving;
extern volatile int kbd_recv_cnt;
extern volatile long last_kbd_modified;


extern volatile struct buffer psm_recv_data;
extern volatile int psm_recv_cnt;
extern volatile int psm_recving;
extern volatile int psm_sending;
extern volatile int psm_send_cnt;
extern volatile long last_psm_modified;

extern volatile struct buffer sio0_recv_data;
extern volatile struct buffer sio0_send_data;

extern volatile struct buffer sio1_recv_data;
extern volatile struct buffer sio1_send_data;

struct pcconf {
	byte kbd_port;
	byte kbd_stat;
	byte kbd_typematic;
	byte kbd_leds;
	byte psm_port;
	byte psm_stat;
	byte psm_resolution;
	byte psm_sampling_rate;
	byte psm_scaling;
};

#define MAX_PC 4

extern struct pcconf pcconf[MAX_PC+1];

extern int cur_kbd;
extern int cur_psm;
extern int cur_disp1;
extern int cur_disp2;

extern int kbd_id1;
extern int kbd_id2;
extern int psm_id;

extern int switcher_on;
extern int func_on;
extern int log_on;

#include "bitmap.h"
#include "hwconfig.h"



#endif
