/* $Id$ */
#include "common.h"
#include "psdev.h"

extern int cur_kbd;
extern int cur_psm;
extern int cur_disp1;
extern int cur_disp2;

extern int psm_stat;
extern int kbd_stat;
extern unsigned int switcher;
extern int kbdopt;
extern int switcher_on;
extern int func_on;
extern int log_on;

/*****************
*                *
* K  M D1 D2  L  *
* 1  2  1  1  F  *
*                *
******************/

static strcpy(b,s) char *b; char *s; {
	while (*s) {
		*(b++) = *(s++);
	}
	*b = 0;
}

int disp_darty; 
static char buf[17];

disp_mode() {
	strcpy(buf,"K  M D1 D2");
	lcd_puts(0,0,buf);

	strcpy(buf,"          ");
	buf[0] = '0'+cur_kbd;
	buf[3] = '0'+cur_psm;
	buf[6] = '0'+cur_disp1;
	buf[9] = '0'+cur_disp2;
	lcd_puts(0,1,buf);
	if (disp_darty) {
		disp_darty = 0;
		disp_stat();
	}
}

disp_stat() {
	strcpy(buf,"      ");
	if (kbd_stat & 1)		buf[1] = 'K';
	if (pcconf[1].kbd_stat == 1)	buf[2] = '-';
	if (pcconf[2].kbd_stat == 1)	buf[3] = '-';
	if (pcconf[3].kbd_stat == 1)	buf[4] = '-';
	if (pcconf[4].kbd_stat == 1)	buf[5] = '-';
	if (pcconf[1].kbd_stat == 2)	buf[2] = '1';
	if (pcconf[2].kbd_stat == 2)	buf[3] = '2';
	if (pcconf[3].kbd_stat == 2)	buf[4] = '3';
	if (pcconf[4].kbd_stat == 2)	buf[5] = '4';
	lcd_puts(10,0,buf);

	strcpy(buf,"      ");
	if (psm_stat & 1)		buf[1] = 'M';

	if (switcher_on)		buf[3] = 'S';
	if (func_on)			buf[4] = 'F';
	if (log_on)			buf[5] = 'L';
	lcd_puts(10,1,buf);
	if (disp_darty) {
		disp_darty = 0;
		disp_mode();
	}
}

disp_conf() {
	static int i;
	int p;

	if (i==0) {
		         /* 0123456789012345 */
		strcpy(buf,"SWITCHER   ---  ");
		if (switcher == CODE_CTRL) {
			buf[11] = 'C';
			buf[12] = 'T';
			buf[13] = 'R';
			buf[14] = 'L';
		} else if (switcher == CODE_RCTRL) {
			buf[11] = 'R';
			buf[12] = 'C';
			buf[13] = 'T';
			buf[14] = 'R';
			buf[15] = 'L';
		} else if (switcher == CODE_WIN) {
			buf[11] = 'W';
			buf[12] = 'I';
			buf[13] = 'N';
		} else if (switcher == CODE_RWIN) {
			buf[11] = 'R';
			buf[12] = 'W';
			buf[13] = 'I';
			buf[14] = 'N';
		} else {
			tohex(buf+11,(switcher>>8)&0xff);
			tohex(buf+13,(switcher)&0xff);
		}
		lcd_puts(0,0,buf);
		strcpy(buf,"OPTION          ");
		if (kbdopt & 0x01) {
			buf[ 7] = 'S';
			buf[ 8] = 'C';
		}
		if (kbdopt & 0x02) {
			buf[10] = 'N';
			buf[11] = 'C';
		}
		lcd_puts(0,1,buf);
	} else if ((1<=i) && (i<=MAX_PC)) {
		strcpy(buf,"PC1  K=NA  M=NA ");
		buf[2] = '0'+i;
		p = pcconf[i].kbd_port;
		switch (p & 0xf0) {
		case 0x00:
			buf[7] = 'P';
			buf[8] = '1'+ (p & 0xf);
			break;
		case 0x10:
			buf[7] = 'S';
			buf[8] = '1'+(p & 0xf);
		}
		p = pcconf[i].psm_port;
		switch (p & 0xf0) {
		case 0x00:
			buf[13] = 'P';
			buf[14] = '1'+ (p & 0xf);
			break;
		case 0x10:
			buf[13] = 'S';
			buf[14] = '1'+(p & 0xf);
		}
		lcd_puts(0,0,buf);
		strcpy(buf,"PC1  K=NA  M=NA ");
		strcpy(buf,"     S=xx  S=xx ");
		tohex(buf+7, pcconf[i].kbd_stat);
		tohex(buf+13,pcconf[i].psm_stat);
		lcd_puts(0,1,buf);
	}
	i++;
	if (i>MAX_PC) i=0;
	disp_darty = 1;
}


const char *usage[] = {
	" with switcher..",
	"F1..F4  kbd & m ",
	"F5..F8  disp1   ",
	"F9..F12 disp2   ",
	"1234   display 1",
	"QWER   display 2",
	"ASDF   mouse    ",
	"ZXCV   keyboard ",
	"L -- S2 Log mode",
	"M -- show config",
	"U -- show usage ",
	" with switcher &",
	"  ALT ---       ",
	"C     Toggle NC ",
	"S     Toggle SC ",
	"W     Save      ",
	"D     Default   ",
	"CTRL,RCTRL,WIN, ",
	"RWIN chg switcer",
};

disp_usage() {
	static int i;
	int lines = sizeof(usage)/sizeof(usage[0]);
	lcd_puts(0,0,usage[i]);
	lcd_puts(0,1,usage[i+1]);
	i++;
	if (i>=(lines-1)) i=0;
	disp_darty = 1;
}
