/* $Id$ */
#include "common.h"
#include "psdev.h"

byte pa_ddr;
byte pb_ddr;
byte p4_ddr;
byte p2_ddr;

int ierror;
int redled;
int greenled;

revred() {
	redled = !redled;
	if (redled) {
		orb(P5DR,0x02);
	} else {
		andb(P5DR,~0x02);
	}
}

revgreen() {
	greenled = !greenled;
	if (greenled) {
		orb(P5DR,0x01);
	} else {
		andb(P5DR,~0x01);
	}
}

int main(void)
{
	int i,j,s,c,p;

	eni(0x00);


	/* LED */
	outb(P5DDR,0xff);

	timer_init();
	sio0_init();
	sio1_init();
	kbd_init();
	psm_init();
	pc_init();
	lcd_init();
	eeprom_init();
	lcd_puts(0,0,"Key/Mouse       ");
	lcd_puts(0,1,"   Switcher     ");
	sleep(1000);
	lcd_puts(0,0,"Designed by     ");
	lcd_puts(0,1,"  Koji Suzuki   ");
	sleep(1000);
	lcd_clear();

	sw_init();
	for (;;) {
		sw_doscan();
		if ((systicks /500) & 1) {
			orb(P5DR,0x01);
		} else {
			andb(P5DR,~0x01);
		}
	}
}


printb(posx,posy,w,x) int x; {
	int i;

	i = 16 - w;
	lcd_locate(posx,posy);
	for (; i<16; i++) {
		lcd_putc( (x & (0x8000>>i))?'1':'0');
	}
}

printx(pos,w,x) int x; {
	int i,y,c;

	i = 4 - w;
	for (; i<4; i++) {
		y = (x >> ((3-i)*4) ) & 0xf;
		c = ( (y > 9)? ( 'A' + y - 10 ): ('0' + y));
		if (pos == 0)
			putc0(c);
		else
			putc1(c);
	}
}

static char lmes0[17] = "                ";
static char lmes1[17] = "                ";

putc0(x) {
	int i;

	for (i=0; i<15; i++) {
		lmes0[i] = lmes0[i+1];
	}
	lmes0[i] = x;
	sio1_send(x);
#ifdef LCDMON
	lcd_puts(0,0,lmes0);
#endif
}

putc1(x) {
	int i;

	for (i=0; i<15; i++) {
		lmes1[i] = lmes1[i+1];
	}
	lmes1[i] = x;
	sio1_send(x);
#ifdef LCDMON
	lcd_puts(0,1,lmes1);
#endif
}

puts0(str) char *str; {
	while (*str) {
		putc0(*str);
		str++;
	}
}

puts1(str) char *str; {
	while (*str) {
		putc1(*str);
		str++;
	}
}

#pragma interrupt
void int_nmi(void)
{
	ierror |= 0x0100;
	lcd_puts(0,1,"error int nmi");
	for (;;);
}
#pragma interrupt
void int_adi(void)
{
	ierror |= 0x0200;
	lcd_puts(0,1,"error int adi");
	for (;;);
}

#include "checkint.c"
