/* $Id$ */
#include "common.h"
/*
	Lcd.c		HD44780 LCDȥɥ饤Сʣߣб

	AKI-H8ޥܡɽ
	J6򥢡CN3-13³Ƥɤ(LCDR/~W)
        ΥСǤϡbusy åϤƤʤbusy å
        ɤ򤹤뤫Τʤ

	                        LCD (Data4bit)
				p3-0  D4
				p3-1  D5
				p3-2  D6
				p3-3  D7
				p3-4  RS
				p3-5  E
				( p3-6  R/~W (¤) )

        ꥸʥǤǸϰʲ̤ꡣ
        ꥸʥǤϥƥץ졼ȤȤѤƤ餤ޤ
        åѹƤޤ

	Copyright (C) 1998, Office SoftBone
	SoftBone ɽ ұ
	ttanaka@cb3.so-net.ne.jp
	http://www02.so-net.ne.jp/~ttanaka
*/

#define LCD_DDR	P3DDR
#define LCD_DR	P3DR

static int lcdx, lcdy;
/*
	LCD Drive primitive
	Data length = 4bits
*/

#define ASSERT_RS()		{ orb(LCD_DR,0x10);} /* set BIT 4 */
#define ASSERT_E()		{ orb(LCD_DR,0x20);} /* set BIT 5 */

#define NEGATE_RS()		{ andb(LCD_DR,~0x10);} /* clear BIT 4 */
#define NEGATE_E()		{ andb(LCD_DR,~0x20);} /* clear BIT 5 */

#define WRITE_DATA( x )	{ outb(LCD_DR, (inb(LCD_DR) & 0xf0) | ((x) & 0x0f)); }


static LcdWrite(data) int data; {

	delay(40);

	ASSERT_E();
	WRITE_DATA( data >> 4 );

	nop();
	NEGATE_E();
	
	nop();
	
	ASSERT_E();
	WRITE_DATA( data );
	nop();
	NEGATE_E();
}


static LcdWriteIR4(data) int data; {
	NEGATE_RS();
	nop();

	ASSERT_E();
	WRITE_DATA( data );
	nop();
	NEGATE_E();
}


static LcdWriteIR(data) int data; {
	NEGATE_RS();
	LcdWrite( data );
}


static LcdWriteDR(data) int data; {
	ASSERT_RS();
	LcdWrite( data );
}


lcd_init() {
	/* Reset LCD */
	outb(LCD_DDR,0xff);			/* LCD饤 */
	outb(LCD_DR,0);


	/*  */
	sleep( 15 );			/* Wait 20 ms */
	LcdWriteIR4( 0x3 );
	sleep( 4 );
	LcdWriteIR4( 0x3 );
	sleep( 4 );
	LcdWriteIR4( 0x3 );
	sleep( 4 );
	LcdWriteIR4( 0x2 );		/* Set function */
	sleep( 4 );

	LcdWriteIR( 0x28 );		/* Set function */
	LcdWriteIR( 0x08 );		/* Display off, cursor off, blink off */
	LcdWriteIR( 0x01 );		/* Clear display */
	sleep( 2 );
	LcdWriteIR( 0x06 );		/* Entry mode : cursor increment */
	LcdWriteIR( 0x0C );		/* Display on, cursor off, blink off */
	lcdx = lcdy = 0;
}


lcd_locate(x,y) int x; int y; {
	int addr;

	switch ( y )
		{
		case 0:		addr = 0x00 + x;	break;
		case 1:		addr = 0x40 + x;	break;
		case 2:		addr = 0x14 + x;	break;
		case 3:		addr = 0x54 + x;	break;
		default:
			return;
		}

	lcdx = x;
	lcdy = y;
	LcdWriteIR( 0x80 | addr );		/* Set DD RAM address */
}


lcd_clear() {
	LcdWriteIR( 0x01 );
	sleep(2);
	lcdx = lcdy = 0;
}


lcd_cursor_mode(on) int on; {
	LcdWriteIR( 0x0C | ( on ? 0x02 : 0 ) );
}


LcdBS() {
	if ( ! lcdx )
		return;
	lcdx--;
	lcd_locate( lcdx, lcdy );
}


lcd_putc(c) int c; {
	if ( c == '\b' )
		{
		LcdBS();
		return;
		}
	LcdWriteDR( c );
	lcdx++;
}


lcd_puts(x,y,str) char *str; {
	lcd_locate(x,y);
	while ( *str )
		lcd_putc( *(str++) );
}



