/* $Id$ */
#include "common.h"
#include "psdev.h"

/*

pcport.c --- PC³ѥݡȡ

Τ褦³


		CLK		DATA
pcport1		portb-4		portb-5
pcport2		portb-6		portb-7
pcport3		port2-0		port2-1
pcport4		port2-1		port2-3
pcport5		port2-6		port2-7
pcport6		port5-2		port5-3

pcport5,6 ϡͽ


 */

#define MAX_PCPORT	4
const struct pcport {
	long port;
	long ddr;
	volatile byte *ddrp;
	int clk_bit;
	int data_bit;
} pcport[MAX_PCPORT] = {
{ PBDR, PBDDR, &pb_ddr, 4,5},
{ PBDR, PBDDR, &pb_ddr, 6,7},
{ P2DR, P2DDR, &p2_ddr, 0,1},
{ P2DR, P2DDR, &p2_ddr, 2,3},
//{ P2DR, P2DDR, &p2_ddr, 6,7},
//{ P5DR, P5DDR, &p5_ddr, 2,3},
};

int inh_cnt[MAX_PCPORT];

pc_init() {
	int i;
	for (i=0; i<MAX_PCPORT; i++) {
		inh_cnt[i] = 0;
	}
}

#if 0
pc_send(port,dat) {
	int i,c;
	for (i=0; i<1; i++) {
		if (((c = _pc_send(port,dat)) >= 0) || (c == -2))
			break;
	}
	return c;
}
#endif

/* L01234567PH */
pc_send(port,dat) {
	const struct pcport *p;
	int clk_mask;
	int data_mask;
	int i,s;
	int sdata;

	p = &pcport[port];
	data_mask = (1<< p->data_bit);
	clk_mask = (1<< p->clk_bit);
	if ((inb(p->port) & data_mask) == 0) return -2;	/* to recv from pc */
	for (i=0; i<60; i++) {
		if (inb(p->port) & clk_mask) break;
		delay(500);
	}
	if ((inb(p->port) & clk_mask) == 0) return -1;	/* inhbit from pc */

	sdata = 0 | ((dat << 1) & 0x1fe) | (parity(dat)?0:0x200) | 0x400 ;
	for (i=0; i<11; i++) {
#if 0
		if (!(inb(p->port) & clk_mask)) {
			s = inh();
			*(p->ddrp) &= ~(data_mask|clk_mask);
			outb(p->ddr,*(p->ddrp));
			eni(s);
			return -(4+i);
		} 
#endif
		if (sdata & 1) {
			s = inh();
			*(p->ddrp) &= ~data_mask;
			outb(p->ddr,*(p->ddrp));
			eni(s);
			if (!(inb(p->port) & data_mask)) {
				s = inh();
				*(p->ddrp) &= ~(data_mask|clk_mask);
				outb(p->ddr,*(p->ddrp));
				eni(s);
				return -3;
			}
		} else {
			s = inh();
			*(p->ddrp) |= data_mask;
			outb(p->ddr,*(p->ddrp));
			eni(s);
		}
		s = inh();
		*(p->ddrp) |= clk_mask;
		outb(p->ddr,*(p->ddrp));
		eni(s);

		delay(50);
		s = inh();
		*(p->ddrp) &= ~clk_mask;
		outb(p->ddr,*(p->ddrp));
		eni(s);
		delay(50);
		sdata >>= 1;
	}
	s = inh();
	*(p->ddrp) &= ~(data_mask|clk_mask);
	outb(p->ddr,*(p->ddrp));
	eni(s);
	delay(100);
	return 0;
}

pc_get(port,timeout) {
	const struct pcport *p;
	int clk_mask;
	int data_mask;
	int i;
	int rdata = 0;
	long t;

	t = systicks;
	p = &pcport[port];
	data_mask = (1<< p->data_bit);
	clk_mask = (1<< p->clk_bit);

	while (systicks - t < timeout) {
		if ( ((inb(p->port) & clk_mask) != 0) 
		  && ((inb(p->port) & data_mask) == 0) ) break;
		delay(300);
	}
	return pc_recv(port);
}

/* L01234567PH */
pc_recv(port) {
	const struct pcport *p;
	int clk_mask;
	int data_mask;
	int i,s;
	int rdata = 0;

	p = &pcport[port];
	data_mask = (1<< p->data_bit);
	clk_mask = (1<< p->clk_bit);
	if ((inb(p->port) & clk_mask) == 0) return -1; /* inhibit form pc */
	if ((inb(p->port) & data_mask) != 0) return -2; 

	for (i=0; i<10; i++) {
		rdata >>= 1;
		s = inh();
		*(p->ddrp) |= clk_mask;
		outb(p->ddr,*(p->ddrp));
		eni(s);
		delay(50);
		if (inb(p->port) & data_mask) {
			rdata |= 0x200;
		}
		s = inh();
		*(p->ddrp) &= ~clk_mask;
		outb(p->ddr,*(p->ddrp));
		eni(s);
		delay(50);
	}
	if (inb(p->port) & data_mask) {
		s = inh();
		*(p->ddrp) |= data_mask;
		outb(p->ddr,*(p->ddrp));
		eni(s);
		s = inh();
		*(p->ddrp) |= clk_mask;
		outb(p->ddr,*(p->ddrp));
		eni(s);
		delay(50);
		s = inh();
		*(p->ddrp) &= ~clk_mask;
		outb(p->ddr,*(p->ddrp));
		eni(s);
		s = inh();
		*(p->ddrp) &= ~data_mask;
		outb(p->ddr,*(p->ddrp));
		eni(s);
		delay(50);

	} else {
		while (!(inb(p->port) & data_mask)) {
			s = inh();
			*(p->ddrp) |= clk_mask;
			outb(p->ddr,*(p->ddrp));
			eni(s);
			delay(50);
			s = inh();
			*(p->ddrp) &= ~clk_mask;
			outb(p->ddr,*(p->ddrp));
			eni(s);
			delay(50);
		}
		return -3;
	}
	if (parity(rdata & 0xff)) {
		if (rdata & 0x100) return -4;
	} else {
		if (!(rdata & 0x100)) return -4;
	}
	return (rdata & 0xff);
}

pc_to_recv() {
	const struct pcport *p;
	int clk_mask;
	int data_mask;
	int i,c;

	for (i=0; i< MAX_PCPORT; i++) {
		p = &pcport[i];
		data_mask = (1<< p->data_bit);
		clk_mask = (1<< p->clk_bit);
		if ((inb(p->port) & clk_mask) == 0) {
			if (inh_cnt[i] < 20000) {
				inh_cnt[i]++;
			}
			continue;
		}
		c = inh_cnt[i];
		inh_cnt[i] = 0;
		if ((inb(p->port) & data_mask) == 0) return i; 
	}
	return -1;
}

pc_stat(port) {
	const struct pcport *p;
	int clk_mask;
	int data_mask;
	int c = 0;

	p = &pcport[port];
	data_mask = (1<< p->data_bit);
	clk_mask = (1<< p->clk_bit);
	if (inb(p->port) & clk_mask)  c |= 0x10;
	if (*(p->ddrp) & clk_mask)    c |= 0x20;
	if (inb(p->port) & data_mask) c |= 0x01;
	if (*(p->ddrp) & data_mask)   c |= 0x02;
	return c;
}
