/* $Id$ */
/* common commands */
#define CMD_RESET	     	0xff
#define CMD_ENABLE		0xf4
#define CMD_DISABLE		0xf5
#define CMD_SET_DEFAULTS	0xf6
#define CMD_SEND_DEV_ID		0xf2

/* keyboard commands */
#define CMD_SET_LEDS		0xed
	/* bit0: ScrollLock bit1:NumLock bit2: CapsLock */
#define CMD_ECHO		0xee
#define CMD_SET_SCANCODE_SET	0xf0
#define CMD_SET_TYPEMATIC	0xf3

/* ps mouse commands */
#define CMD_SEND_DEV_STATUS 	0xe9
#define CMD_SEND_DEV_DATA	0xeb
#define CMD_SET_SCALING11	0xe6
#define CMD_SET_SCALING21	0xe7
#define CMD_SET_RESOLUTION	0xe8
#define CMD_SET_STREAM_MODE	0xea
#define CMD_SET_REMOTE_MODE	0xf0
#define CMD_SET_SAMPLING_RATE	0xf3

/* common return code */
#define RC_ACK 		0xfa
#define RC_RESEND	0xfe
#define RC_RESET_DONE	0xaa
#define RC_RESET_FAIL	0xfc

/* keyboard return code */
#define RC_DIAG_DONE	0x55
#define RC_DIAG_FAIL	0xfd
#define RC_ECHO		0xee


/* keycode */

#define CODE_RELEASE		0xf0
#define CODE_EXT1		0xe0
#define CODE_EXT2		0xe1

#define CODE_CTRL		0x14
#define CODE_CAPS		0x58
#define CODE_ALT		0x11
#define CODE_SHIFT		0x12
#define CODE_SPACE		0x29
#define CODE_ESC		0x76
#define CODE_WIN		0xe01f

#define CODE_RSHIFT		0x59
#define CODE_RALT		0xe011
#define CODE_INS		0xe070
#define CODE_RWIN		0xe027
#define CODE_RCTRL		0xe014
#define CODE_ENTER		0x5a


#define CODE_F1		0x05
#define CODE_F2		0x06
#define CODE_F3		0x04
#define CODE_F4		0x0c
#define CODE_F5		0x03
#define CODE_F6		0x0b
#define CODE_F7		0x83
#define CODE_F8		0x0a
#define CODE_F9		0x01
#define CODE_F10	0x09
#define CODE_F11	0x78
#define CODE_F12	0x07

#define CODE_1		0x16
#define CODE_2		0x1e
#define CODE_3		0x26
#define CODE_4		0x25
#define CODE_5		0x2e
#define CODE_6		0x36
#define CODE_7		0x3d
#define CODE_8		0x3e
#define CODE_9		0x46
#define CODE_0		0x45

#define CODE_A		0x1c
#define CODE_B		0x32
#define CODE_C		0x21
#define CODE_D		0x23
#define CODE_E		0x24
#define CODE_F		0x2b
#define CODE_G		0x34
#define CODE_H		0x33
#define CODE_I		0x43
#define CODE_J		0x3b
#define CODE_K		0x42
#define CODE_L		0x4b
#define CODE_M		0x3a
#define CODE_N		0x31
#define CODE_O		0x44
#define CODE_P		0x4d
#define CODE_Q		0x15
#define CODE_R		0x2d
#define CODE_S		0x1b
#define CODE_T		0x2c
#define CODE_U		0x3c
#define CODE_V		0x2a
#define CODE_W		0x1d
#define CODE_X		0x22
#define CODE_Y		0x35
#define CODE_Z		0x1a
