/* $Id$ */
#include "common.h"

/*

sio.c --- sio0 ɥ饤С

sio1_init() --- sio0  9600 bps ǽϤϳߥ١

sio1_set_mode(bps,bits,parity,stop) --- sio Υѥ᡼ꡣ
                        bps ϡ110 -- 38400 餤ޤǤ


sio1_send(ch) ch С


*/


volatile struct buffer sio1_recv_data;
volatile struct buffer sio1_send_data;

sio1_init() {
	buffer_init(&sio1_recv_data);
	buffer_init(&sio1_send_data);
	outb(SMR1,0);
	outb(BRR1,51);
	delay(1000);
	outb(SCR1,0x70); /* RIE,RE,TXI on */

}

#define BITS8	0
#define BITS7	1

#define PNONE	0
#define PEVEN	2
#define PODD	3

#define STOP1	0
#define STOP2	1


static sio_set_mode(bps,bits,parity,stop,sp,bp) int *sp,*bp; {
	long t;
	int smr = 0;
	int ret = 0;

	t = MCLOCK * 1000000 / 32 / bps;
	if ( (MCLOCK * 1000000 -  t * 32 * bps) > 
	   ( (t+1) * 32 * bps - MCLOCK * 1000000) )
		t++;

	if (t < 256) {
	} else if (  t < 256 * 4) {
		smr |= 1;
		t /= 4;
	} else if (  t < 256 * 16) {
		smr |= 2;
		t /= 16;
	} else if (  t < 256 * 64) {
		smr |= 3;
		t /= 64;
	} else {
		ret = 1;
		t = 255;
	}
	if (bits == 1) smr |= 64;
	if (parity == 2) smr |= 32;
	if (parity == 3) smr |= 32 | 16;
	if (stop ==1) smr |= 8;
	*sp = smr;
	*bp = t;
	return ret;
}

sio1_set_mode(bps,bits,parity,stop) {
	int smr,brr;
	if ( sio_set_mode(bps,bits,parity,stop,&smr,&brr)) return;
	outb(SMR1,smr);
	outb(BRR1,brr);
	delay(1000);
}

sio1_send(byte ch)
{
    int s;
    while (buffer_full(&sio1_send_data)) {
	;
    }
    s = inh();
    if (inb(SCR1)&0x04) {
	buffer_put(&sio1_send_data,ch);
    } else {
    	outb(TDR1,ch);
    	andb(SSR1,~0x80);
	orb(SCR1,0x04);
    }
    eni(s);
}

#pragma interrupt
int_tei1() {
	int dat;
	andb(SCR1,~0x04);
	if (buffer_exist(&sio1_send_data)) {
		dat = buffer_get(&sio1_send_data);
    		if ((inb(SSR1)&0x80)) {
    			outb(TDR1,dat);
    			andb(SSR1,~0x80);
			orb(SCR1,0x04);
		}
	}
}

#pragma interrupt
int_rxi1() {
	byte dat;
	dat = inb(RDR1);
	buffer_put(&sio1_recv_data,dat);
	andb(SSR1,~0x40);
}


#pragma interrupt
int_eri1() {
	andb(SSR1,~0x38);	/* 5: ORER 4: FER 3:PER */
}
