#include <termios.h>
#include <stdio.h>

/*  |LB|RB| 1|Y5|Y4|X5|X4|
    |  |  | 0|X3|X2|X1|X0|
    |  |  | 0|Y3|Y2|Y1|Y0|
    |  |  |MB|  |  |  |  |
*/
  
int commfd;

void init_comm(char* SerialDevice)
{
    struct termios termios;
    struct termios termios2;

    commfd=open(SerialDevice,2);
    if(commfd<0){
	perror("init_comm");
	exit(1);
    }
    tcgetattr(commfd,&termios);
    cfsetispeed(&termios,B1200);
    cfsetospeed(&termios,B1200);
    cfmakeraw(&termios);
    termios.c_cflag |=HUPCL|CLOCAL;
    termios.c_cflag &= ~(PARENB|CSTOPB);
    termios.c_cflag &= ~(CSIZE);
    termios.c_cflag |= CS7;
    tcsetattr(commfd,TCSANOW,&termios);
    tcgetattr(commfd,&termios2);
    printf("ispeed %d \n",cfgetispeed(&termios2));
    printf("ospeed %d \n",cfgetospeed(&termios2));
    if ((termios2.c_cflag & CSIZE) == CS8) {
		printf("CS8\n");
    }
    if ((termios2.c_cflag & CSIZE) == CS7) {
		printf("CS7\n");
    }
}


main() {
	unsigned char buf[256];
	int i,ret;
	char x,y;
	int l,r;

	init_comm("/dev/cuaa0");
#if 0
	//if (Logitech 3 button mouse) echo next
	buf[0] = 0x40;
	for (i=0;i<0x40; i++) {
		buf[0] = i;
		write(commfd,buf,1);
		ret = read(commfd,buf,1);
		printf("%02x -- %02x\n",i,buf[0]);
	}
#endif
	for (;;) {
		ret = read(commfd,buf,1);
		if (ret < 0) {
			perror("read");
			exit(1);
		}
		if (!(buf[0] & 0x40)) {
			printf(" %02x --- error \n",buf[0]);
			continue;
		}
		ret = read(commfd,buf+1,1);
		if (ret < 0) {
			perror("read2");
			exit(1);
		}
		if (buf[1] & 0x40) {
			printf(" %02x %02x --- error \n",buf[0],buf[1]);
			continue;
		}
		ret = read(commfd,buf+2,1);
		if (ret < 0) {
			perror("read3");
			exit(1);
		}
		if (buf[2] & 0x40) {
			printf(" %02x %02x %02x --- error \n",buf[0],buf[1],buf[2]);
			continue;
		}
		l = (buf[0] & 0x20);
		r = (buf[0] & 0x10);
		x = ((buf[0] << 6) & 0xc0 ) | (buf[1] & 0x3f);
		y = ((buf[0] << 4) & 0xc0 ) | (buf[2] & 0x3f);

		printf(" %02x %02x %02x --- ",buf[0],buf[1],buf[2]);
		printf("%c %c %2d %3d\n",l?'L':' ',r?'R':' ',x,y);
	}
}

