/* $Id$ */
/* switch.c --- */

#include "common.h"
#include "psdev.h"

struct pcconf pcconf[MAX_PC+1];

int cur_kbd = 1;
int cur_psm = 1;
int cur_disp1 = 1;
int cur_disp2 = 2;

int kbd_id1 = 0xab;
int kbd_id2 = 0x83;
int psm_id = 0;

int kbd_stat;
int psm_stat;
int switcher_on;
int func_on;
int log_on = 1;

#define SWAP_CTRL	0x0001
#define NO_CAPS		0x0002

/* default

int kbdopt = 0;
unsigned int switcher = RCTRL;
*/

int kbdopt = SWAP_CTRL | NO_CAPS;
unsigned int switcher = CODE_CTRL;

sw_init() {
	int i,n;
	int buf[32];
	int j=0;

	disp1_ddr |= DISP1_MASK;
	outb(DISP1_DDR,disp1_ddr);
	disp2_ddr |= DISP2_MASK;
	outb(DISP2_DDR,disp2_ddr);

	/* control */
	sw_kbd_conf(0,0xf0);
	sw_psm_conf(0,0xf0);
	if (0) {
	//if ((eeprom_read(0x80,buf,sizeof(int) * 32) == 0)  && (buf[0] > 0)) {
		j = 0;
		n         = buf[j++];
		cur_kbd   = buf[j++];
		cur_psm   = buf[j++];
		cur_disp1 = buf[j++];
		cur_disp2 = buf[j++];
		switcher  = buf[j++];
		kbdopt    = buf[j++];
		j += 1;

		if (n > MAX_PC) n = MAX_PC;
		for (i=1; i<= n; i++) {
			sw_kbd_conf(i,buf[j++]);
			sw_psm_conf(i,buf[j++]);
		}
		for (; i<= MAX_PC; i++) {
			sw_kbd_conf(i,0xff);
			sw_psm_conf(i,0xff);
		}
	} else {

		sw_kbd_conf(1,0x00);
		sw_psm_conf(1,0x10);

		sw_kbd_conf(2,0x01);
		sw_psm_conf(2,0x11);

		sw_kbd_conf(3,0x03);
		sw_psm_conf(3,0x02);

		for (i=4; i<= MAX_PC; i++) {
			sw_kbd_conf(i,0xff);
			sw_psm_conf(i,0xff);
		}
	}
	switch_kbd(cur_kbd);
	switch_psm(cur_psm);
	switch_disp1(cur_disp1);
	switch_disp2(cur_disp2);
	disp_stat();
}

sw_kbd_conf(p,port) int p; {
	pcconf[p].kbd_port = port;
	pcconf[p].kbd_stat = 0;
	pcconf[p].kbd_leds = 0x0;
	pcconf[p].kbd_typematic = 32;

	if ((port & 0xf0) == 0xf0) {	/* command mode */
		pcconf[p].kbd_leds = 0x7;
		pcconf[p].kbd_stat = 2;
	}
}

sw_psm_conf(p,port) int p; {
	pcconf[p].psm_port = port;
	pcconf[p].psm_stat = 0;
	pcconf[p].psm_scaling = 0;
	pcconf[p].psm_sampling_rate = 10;
	pcconf[p].psm_resolution = 3;

	if (port == 0x10) { /* sio0 */
		pcconf[p].psm_stat = 2;
		sio0_set_mode(1200,7,0,1);
	} else if (port == 0x11) { /* sio1 */
		pcconf[p].psm_stat = 2;
		if (!log_on) {
			sio1_set_mode(1200,7,0,1);
		} else {
			sio0_set_mode(9600,8,0,1);
		}
	}
}

sw_kbd_put(p,c) int p,c; {
	int ret;
	int port = pcconf[p].kbd_port;
	if ((port & 0xf0) == 0) {
		ret = pc_send(port,c);
		log('<','0'+port,ret,c);
	} else {
		ret = -1;
	}
	return ret;
}

sw_kbd_get(p,timeout) int p; {
	int ret;
	int port = pcconf[p].kbd_port;
	if ((port & 0xf0) == 0) {
		ret = pc_get(port,timeout);
		if (!((timeout == 0) && (ret < 0))) log('>','0'+port,ret);
	} else {
		ret = -1;
	}
	return ret;
}

sw_psm_put2(p,buf,len) int p; byte *buf; int len; {
	int i,ret;
	byte sb;
	byte c;
	short x,y;
	int port = pcconf[p].psm_port;

	if ((port & 0xf0) == 0) {
		if (len < 3) return 0;
		for (i=0; i<len; i++) {
			if ((ret = sw_psm_put(p,buf[i])) < 0) return ret;
		}
		return 0;
	} else if ((port & 0xf0) == 0x10) {
		if (len < 3) return 0;
		c = buf[0];
		x = buf[1] | ((c&0x40)?0x100:0) | ((c & 0x10)? 0xff00:0);
		if (x > 127) x = 127;
		if (x < -128) x = -128;
		y = buf[2] | ((c & 0x20)? 0xff00:0);
		if (y > 127) y = 127;
		if (y < -128) y = -128;
		sb = 0x40 
			| ((c&0x01)?0x20:0)
			| ((c&0x02)?0x10:0)
			| (x >> 4) & 0x0c
			| (y >> 6) & 0x03;
		sw_psm_put(p,sb);
		sw_psm_put(p,x & 0x3f);
		sw_psm_put(p,y & 0x3f);
		if (c & 0x04) {
			sw_psm_put(p,0x20);
		}
		return 0;
	}
}

sw_psm_put(p,c) int p,c; {
	int ret;
	int port = pcconf[p].psm_port;
	if ((port & 0xf0) == 0) {
		ret = pc_send(port,c);
		log('<','0'+port,ret,c);
	} else if ( port == 0x10) { /* sio0 */
		ret = sio0_send(c);
		log('<','s',ret,c);
	} else if ( port == 0x11) { /* sio1 */
		if (log_on) return -1;
		ret =  sio1_send(c);
		log('<','t',ret,c);
	} else {
		ret = -1;
	}
	return ret;
}


sw_psm_get(p,timeout) int p; {
	int ret;
	int port = pcconf[p].psm_port;
	if ((port & 0xf0) == 0) {
		ret = pc_get(port,timeout);
		if (!((timeout == 0) && (ret < 0))) log('>','0'+port,ret);
		return ret;
	} else if (port == 0x10) {
		ret = sio0_get(timeout);
		if (0 <= ret && ret <= 0x3f) sio0_send(ret);
		return -1;
	} else if (port == 0x11) {
		if (!log_on) {
			ret = sio1_get(timeout);
			if (0 <= ret && ret <= 0x3f) sio1_send(ret);
		}
		return -1;
	}
	return -1;
}

kbd_get(timeout) int timeout; {
	int ret;
	long t;
	t = systicks;

	while (systicks - t < timeout) {
		if (buffer_exist(&kbd_recv_data)) {
			ret = buffer_get(&kbd_recv_data);
			log('>','k',ret);
			return ret;
		}
	}
	ret = buffer_get(&kbd_recv_data);
	if (!((timeout == 0) && (ret < 0))) log('>','k',ret);
	return ret;
}

psm_get2(buf,timeout) byte *buf; {
	int ret;

	ret = psm_get(timeout);
	if (ret < 0) return ret;
	buf[0] = ret;
	if ((buf[0] & 0x88) != 0x08) return 1;
	ret = psm_get(3);
	if (ret < 0) return 1;
	buf[1] = ret;
	ret = psm_get(3);
	if (ret < 0) return 2;
	buf[2] = ret;
	if (psm_id == 0x00) {
		return 3;
	}
	ret = psm_get(3);
	if (ret < 0) return 3;
	buf[3] = ret;
	return 4;
}

psm_get(timeout) int timeout; {
	int ret;
	long t;
	t = systicks;

	while (systicks - t < timeout) {
		if (buffer_exist(&psm_recv_data)) {
			ret = buffer_get(&psm_recv_data);
			log('>','m',ret);
			return ret;
		}
	}
	ret = buffer_get(&psm_recv_data);
	if (!((timeout == 0) && (ret < 0))) log('>','m',ret);
	return ret;
}

sio0_get(timeout) int timeout; {
	int ret;
	long t;
	t = systicks;

	while (systicks - t < timeout) {
		if (buffer_exist(&sio0_recv_data)) {
			ret = buffer_get(&sio0_recv_data);
			log('>','s',ret);
			return ret;
		}
	}
	ret = buffer_get(&sio0_recv_data);
	if (!((timeout == 0) && (ret < 0))) log('>','s',ret);
	return ret;
}

sio1_get(timeout) int timeout; {
	int ret;
	long t;
	t = systicks;

	while (systicks - t < timeout) {
		if (buffer_exist(&sio1_recv_data)) {
			ret = buffer_get(&sio1_recv_data);
			log('>','t',ret);
			return ret;
		}
	}
	ret = buffer_get(&sio1_recv_data);
	if (!((timeout == 0) && (ret < 0))) log('>','t',ret);
	return ret;
}

kbd_put(c) {
	int ret;
	ret = kbd_send(c);
	log('<','k',ret,c);
	return ret;
}

psm_put(c) {
	int ret;
	ret = psm_send(c);
	log('<','m',ret,c);
	return ret;
}


log(dir,type,ret,c) {
	char buf[3];
	if (!log_on) return;
	sio1_send(dir);
	sio1_send(dir);
	sio1_send(type);
	sio1_send(' ');
	if (dir == '<') {
		tohex(buf,c);
		sio1_send(buf[0]);
		sio1_send(buf[1]);
		if (ret < 0) {
			sio1_send('(');
			tohex(buf,-ret);
			sio1_send(buf[1]);
			sio1_send(')');
		}
	} else {
		if (ret < 0) {
			sio1_send('(');
			tohex(buf,-ret);
			sio1_send(buf[1]);
			sio1_send(')');
		} else {
			tohex(buf,ret);
			sio1_send(buf[0]);
			sio1_send(buf[1]);
		}
	}
	sio1_send('\n');
}

tohex(buf,c) char *buf; {
	int x;
	x = (c >> 4)&0xf;
	if (x >= 10) *buf = 'a'+(x-10);
	else *buf = '0'+x;

	buf++;

	x = c &0xf;
	if (x >= 10) *buf = 'a'+(x-10);
	else *buf = '0'+x;
}


chg_log() {
	log_on = !log_on;
	if (log_on) {
		sio1_set_mode(9600,8,0,1);
	} else {
		sio1_set_mode(1200,7,0,1);
	}
	disp_stat();
}

sw_kbd_execute(p,c) int p,c; {
	int x;
	if (c == CMD_RESET) {
		sw_kbd_put(p,RC_ACK);
		pcconf[p].kbd_stat = 2;
		pcconf[p].kbd_leds = 0x0;
		pcconf[p].kbd_typematic = 32;
		if (p == cur_kbd) {
			switch_kbd(cur_kbd);
		}
		sw_kbd_put(p,RC_RESET_DONE);
		disp_stat();
	} else if (c == CMD_SEND_DEV_ID) {
		if (p == cur_kbd) {
			kbd_flush();
			kbd_put(c);
			if (kbd_get(10) == RC_ACK) {
				kbd_id1 = kbd_get(10);
				kbd_id2 = kbd_get(10);
				if ((kbd_id1 == 0xff) ||(kbd_id2 == 0xff)) {
					kbd_id1 = 0xab;
					kbd_id2 = 0x83;
				}
			}
		}
		sw_kbd_put(p,RC_ACK);
		sw_kbd_put(p,kbd_id1);
		sw_kbd_put(p,kbd_id2);
	} else if (c == CMD_DISABLE) {
		sw_kbd_put(p,RC_ACK);
		/* not really disable */
		pcconf[p].kbd_stat = 1;
		disp_stat();
	} else if (c == CMD_ENABLE) {
		sw_kbd_put(p,RC_ACK);
		if (p == cur_kbd) {
			kbd_flush();
			kbd_put(c);
			kbd_get(10);
		}
		pcconf[p].kbd_stat = 2;
		disp_stat();
	} else if (c == CMD_SET_TYPEMATIC) {
		sw_kbd_put(p,RC_ACK);
		x = sw_kbd_get(p,50);
		sw_kbd_put(p,RC_ACK);
		pcconf[p].kbd_typematic = x;
		if (p == cur_kbd) {
			kbd_flush();
			kbd_put(c);
			if (kbd_get(10) == RC_ACK) {
				kbd_put(x);
				kbd_get(10);
			}
		}
	} else if (c == CMD_SET_LEDS) {
		sw_kbd_put(p,RC_ACK);
		x = sw_kbd_get(p,50);
		sw_kbd_put(p,RC_ACK);
		pcconf[p].kbd_leds = x;
		if (p == cur_kbd) {
			kbd_flush();
			kbd_put(c);
			if (kbd_get(10) == RC_ACK) {
				kbd_put(x);
				kbd_get(10);
			}
		}
	} else {
		if (p == cur_kbd) {
			kbd_put(c);
		}
	}
}

sw_psm_execute(p,c) int p,c; {
	int x;
	if (c == CMD_RESET) {
		sw_psm_put(p,RC_ACK);
		pcconf[p].psm_stat = 1;
		pcconf[p].psm_scaling = 0;
		pcconf[p].psm_sampling_rate = 10;
		pcconf[p].psm_resolution = 3;
		if (p == cur_psm) {
			switch_psm(cur_psm);
		}
		sw_psm_put(p,RC_RESET_DONE);
		sw_psm_put(p,psm_id);
		disp_stat();
	} else if (c == CMD_SEND_DEV_ID) {
		if (p == cur_psm) {
			psm_flush();
			psm_put(c);
			if (psm_get(10) == RC_ACK) {
				psm_id = psm_get(10);
				if (psm_id == 0xff) {
					psm_id = 0;
				}
			}
		}
		sw_psm_put(p,RC_ACK);
		sw_psm_put(p,psm_id);
	} else if (c == CMD_DISABLE) {
		if (p == cur_psm) {
			psm_flush();
			psm_put(c);
			psm_get(10);
		}
		sw_psm_put(p,RC_ACK);
		pcconf[p].psm_stat = 1;
		disp_stat();
	} else if (c == CMD_ENABLE) {
		if (p == cur_psm) {
			psm_flush();
			psm_put(c);
			psm_get(10);
		}
		sw_psm_put(p,RC_ACK);
		pcconf[p].psm_stat = 2;
		disp_stat();
	} else if (c == CMD_SET_RESOLUTION) {
		sw_psm_put(p,RC_ACK);
		x = sw_psm_get(p,50);
		sw_psm_put(p,RC_ACK);
		pcconf[p].psm_resolution = x;
		if (p == cur_psm) {
			psm_flush();
			psm_put(c);
			if (psm_get(10) == RC_ACK) {
				psm_put(x);
				psm_get(10);
			}
		}
	} else if (c == CMD_SET_SAMPLING_RATE) {
		sw_psm_put(p,RC_ACK);
		x = sw_psm_get(p,50);
		sw_psm_put(p,RC_ACK);
		pcconf[p].psm_sampling_rate = x;
		if (p == cur_psm) {
			psm_flush();
			psm_put(c);
			if (psm_get(10) == RC_ACK) {
				psm_put(x);
				psm_get(10);
			}
		}
	} else if (c == CMD_SET_SCALING11) {
		sw_psm_put(p,RC_ACK);
		pcconf[p].psm_scaling = 0;
		if (p == cur_psm) {
			psm_flush();
			psm_put(c);
			psm_get(10);
		}
	} else if (c == CMD_SET_SCALING21) {
		sw_psm_put(p,RC_ACK);
		pcconf[p].psm_scaling = 1;
		if (p == cur_psm) {
			psm_flush();
			psm_put(c);
			psm_get(10);
		}
	} else {
		if (p == cur_psm) {
			psm_put(c);
		}
	}
}

switch_disp1(p) {
	int x;

	x = inb(DISP1_PORT);
	switch (p) {
	case 1:
		x &= ~DISP1_MASK;
		x |= (3 << DISP1_BIT);
		cur_disp1 = p;
		break;
	case 2:
		x &= ~DISP1_MASK;
		x |= (2 << DISP1_BIT);
		cur_disp1 = p;
		break;
	case 3:
		x &= ~DISP1_MASK;
		x |= (1 << DISP1_BIT);
		cur_disp1 = p;
		break;
	case 4:
		x &= ~DISP1_MASK;
		x |= (0 << DISP1_BIT);
		cur_disp1 = p;
		break;
	}
	outb(DISP1_PORT,x);
	disp_mode();
}

switch_disp2(p) {
	int x;

	x = inb(DISP2_PORT);
	switch (p) {
	case 1:
		x &= ~DISP2_MASK;
		x |= (3 << DISP2_BIT);
		cur_disp2 = p;
		break;
	case 2:
		x &= ~DISP2_MASK;
		x |= (2 << DISP2_BIT);
		cur_disp2 = p;
		break;
	case 3:
		x &= ~DISP2_MASK;
		x |= (1 << DISP2_BIT);
		cur_disp2 = p;
		break;
	case 4:
		x &= ~DISP2_MASK;
		x |= (0 << DISP2_BIT);
		cur_disp2 = p;
		break;
	}
	outb(DISP2_PORT,x);
	disp_mode();
}


switch_kbd(p) {
	int i,c;

	for (i=0; i<3; i++) {
		kbd_flush();
		kbd_put(CMD_SEND_DEV_ID);
		if (kbd_get(10) == RC_ACK) {
			kbd_id1 = kbd_get(10);
			kbd_id2 = kbd_get(10);
			if ((kbd_id1 == 0xff) || (kbd_id2 == 0xff)) {
				kbd_id1 = 0xab;
				kbd_id2 = 0x83;
			} else {
				break;
			}
		}
	}
	if (i == 3) {
		if (kbd_stat & 1) {
			kbd_stat &= ~1;
			disp_stat();
		}
		return -1;
	}


	for (i=0; i<3; i++) {
		kbd_put(CMD_SET_LEDS);
		if (kbd_get(10) == RC_ACK) {
			kbd_put(pcconf[p].kbd_leds);
			if (kbd_get(10) == RC_ACK) break;
		}
	}

	for (i=0; i<3; i++) {
		kbd_put(CMD_SET_TYPEMATIC);
		if (kbd_get(10) == RC_ACK) {
			kbd_put(pcconf[p].kbd_typematic);
			if (kbd_get(10) == RC_ACK) break;
		}
	}

	for (i=0; i<3; i++) {
		kbd_put(CMD_ENABLE);
		if (kbd_get(10) == RC_ACK) break;
	}
	cur_kbd = p;
	if (!(kbd_stat & 1)) {
		kbd_stat |= 1;
		disp_stat();
	}
	disp_mode();
	return 0;
}

switch_psm(p) int p; {
	int i;

	for (i=0; i<3; i++) {
		psm_flush();
		psm_put(CMD_DISABLE);
		if (psm_get(10) == RC_ACK) {
			break; 
		}
	}
	if (i == 3) {
		if (psm_stat & 1) {
			psm_stat &= ~1;
			disp_stat();
		}
		return -1;
	}

	for (i=0; i<3; i++) {
		psm_put(CMD_SET_RESOLUTION);
		if (psm_get(10) == RC_ACK) {
			psm_put(pcconf[p].psm_resolution);
			if (psm_get(10) == RC_ACK) break;
		}
	}

	if (pcconf[p].psm_scaling == 0) {
		for (i=0; i<3; i++) {
			psm_put(CMD_SET_SCALING11);
			if (psm_get(10) == RC_ACK) break;
		}
	} else if (pcconf[p].psm_scaling == 1) {
		for (i=0; i<3; i++) {
			psm_put(CMD_SET_SCALING21);
			if (psm_get(10) == RC_ACK) break;
		}
	}

	for (i=0; i<3; i++) {
		psm_put(CMD_SET_SAMPLING_RATE);
		if (psm_get(10) == RC_ACK) {
			psm_put(pcconf[p].psm_sampling_rate);
			if (psm_get(10) == RC_ACK) break;
		}
	}

	if (pcconf[p].psm_stat == 2) {
		for (i=0; i<3; i++) {
			psm_put(CMD_ENABLE);
			if (psm_get(10) == RC_ACK) break;
		}
	}
	cur_psm = p;
	if (!(psm_stat & 1)) {
		psm_stat |= 1;
		disp_stat();
	}
	disp_mode();
	return 0;
}


kbd_get2(timeout,codep) unsigned int *codep; {
	int c;
	int released = 0;
	unsigned int code;

	if ((c = kbd_get(timeout)) >= 0) {
		code = c;
		released = 0;
		if (c == CODE_RELEASE) {
			released = 1;
			c = kbd_get(10);
			if (c < 0) goto err;
			code = c;
		}
		if (code == CODE_EXT1 || code == CODE_EXT2) {
			code <<= 8;
			c = kbd_get(10);
			if (c < 0) goto err;
			code |= c;
		}
	} else {
		return -1;
	}
	*codep = code;
	return released;
err:
	return -1;
}

sw_doscan() {
	int i,c;
	unsigned int code;
	int released;
	byte buf[6];

	for (i=1; i<= MAX_PC; i++) {
		if ( (c = sw_kbd_get(i,0)) >= 0) {
			sw_kbd_execute(i,c);
		}
	}
	for (i=1; i<= MAX_PC; i++) {
		if ( (c = sw_psm_get(i,0)) >= 0) {
			sw_psm_execute(i,c);
		}
	}
	if ((released = kbd_get2(0,&code)) >= 0) {
		if (code == switcher) {
			if (released) goto brk;
			switcher_on = 1;
			disp_stat();
			for (;;) {
				if ((released = kbd_get2(10,&code)) < 0) {
					continue;
				}
				if ((code == switcher) && released) {
					break;
				}
				if (released) {
					if ((code == CODE_ALT)
					     || (code == CODE_RALT)) {
						func_on = 0;
						disp_stat();
					}
					continue;
				}
				switch(code) {
				case CODE_F1:
					switch_kbd(1);
					switch_psm(1);
					goto brk;
				case CODE_F2:
					switch_kbd(2);
					switch_psm(2);
					goto brk;
				case CODE_F3:
					switch_kbd(3);
					switch_psm(3);
					goto brk;
				case CODE_F4:
					switch_kbd(4);
					switch_psm(4);
					goto brk;
				case CODE_F5:
				case CODE_1:
					if (func_on) {
						func1();
						goto brk;
					}
					switch_disp1(1);
					break;
				case CODE_F6:
				case CODE_2:
					if (func_on) {
						func2();
						goto brk;
					}
					switch_disp1(2);
					break;
				case CODE_F7:
				case CODE_3:
					if (func_on) {
						func3();
						goto brk;
					}
					switch_disp1(3);
					break;
				case CODE_F8:
				case CODE_4:
					if (func_on) {
						func4();
						goto brk;
					}
					switch_disp1(4);
					break;
				case CODE_5:
					if (func_on) {
						func5();
						goto brk;
					}
					break;
				case CODE_6:
					if (func_on) {
						func6();
						goto brk;
					}
					break;
				case CODE_7:
					if (func_on) {
						func7();
						goto brk;
					}
					break;
				case CODE_8:
					if (func_on) {
						func8();
						goto brk;
					}
					break;
				case CODE_9:
					if (func_on) {
						func9();
						goto brk;
					}
					break;
				case CODE_F9:
				case CODE_Q:
					switch_disp2(1);
					break;
				case CODE_F10:
				case CODE_W:
					switch_disp2(2);
					break;
				case CODE_F11:
				case CODE_E:
					switch_disp2(3);
					break;
				case CODE_F12:
				case CODE_R:
					switch_disp2(4);
					break;
				case CODE_A:
					switch_psm(1);
					break;
				case CODE_S:
					if (func_on) {
						if (kbdopt & SWAP_CTRL) {
							kbdopt &= ~SWAP_CTRL;
						} else {
							kbdopt |= SWAP_CTRL;
						}
						break;
					}
					switch_psm(2);
					break;
				case CODE_D:
					if (func_on) {
						/* set Default */
						goto brk;
					}
					switch_psm(3);
					break;
				case CODE_F:
					switch_psm(4);
					break;
				case CODE_G:
					switch_psm(5);
					break;
				case CODE_H:
					switch_psm(6);
					break;
				case CODE_Z:
					switch_kbd(1);
					goto brk;
				case CODE_X:
					switch_kbd(2);
					goto brk;
				case CODE_C:
					if (func_on) {
						if (kbdopt & NO_CAPS) {
							kbdopt &= ~NO_CAPS;
						} else {
							kbdopt |= NO_CAPS;
						}
						break;
					}
					switch_kbd(3);
					goto brk;
				case CODE_V:
					switch_kbd(4);
					goto brk;
				case CODE_B:
					switch_kbd(5);
					goto brk;
				case CODE_N:
					switch_kbd(6);
					goto brk;
				case CODE_ALT:
				case CODE_RALT:
					func_on = 1;
					disp_stat();
					break;
				case CODE_L:
					chg_log();
					break;
				case CODE_M:
					disp_conf();
					break;
				case CODE_U:
					disp_usage();
					break;
				case CODE_CTRL:
					if (func_on&&(switcher!=CODE_CTRL)){
						switcher = CODE_CTRL;
						goto brk;
					}
					break;
				case CODE_RCTRL:
					if (func_on&&(switcher!=CODE_RCTRL)){
						switcher = CODE_RCTRL;
						goto brk;
					}
					break;
				case CODE_WIN:
					if (func_on&&(switcher!=CODE_WIN)){
						switcher = CODE_WIN;
						goto brk;
					}
					break;
				case CODE_RWIN:
					if (func_on&&(switcher!=CODE_RWIN)){
						switcher = CODE_RWIN;
						goto brk;
					}
					break;
				}
			}
brk:
			switcher_on = 0;
			func_on = 0;
			disp_stat();
		} else if (code == RC_RESET_DONE) {
			switch_kbd(cur_kbd);
		} else {
			if (kbdopt & SWAP_CTRL) {
				if (code == CODE_CAPS) code = CODE_CTRL;
				else if (code == CODE_CTRL) code = CODE_CAPS;
			}
			if ( (pcconf[cur_kbd].kbd_stat == 1) ||
			   ((kbdopt & NO_CAPS) && (code == CODE_CAPS))) {
				goto nextop;
			}
			if (released) sw_kbd_put(cur_kbd,CODE_RELEASE);
			if (code & 0xff00) {
				sw_kbd_put(cur_kbd,(code >> 8)&0xff);
			}
			sw_kbd_put(cur_kbd,code&0xff);
		}
	}
nextop:
	if ((c = psm_get2(buf,0)) > 0) {
		sw_psm_put2(cur_psm,buf,c);
	}
}
