/* $Id$ */
#include "common.h"
#include "psdev.h"

byte pa_ddr;
byte pb_ddr;
byte p4_ddr;
byte p2_ddr;

int sgetch(void);
void sputch(int ch);

int ierror;
int redled;
int greenled;

revred() {
	redled = !redled;
	if (redled) {
		orb(P5DR,0x02);
	} else {
		andb(P5DR,~0x02);
	}
}

revgreen() {
	greenled = !greenled;
	if (greenled) {
		orb(P5DR,0x01);
	} else {
		andb(P5DR,~0x01);
	}
}

int main(void)
{
	int i,j,s;
	int dat_cnt;
	int prev4 = 0xff;
	int dat[6];

	eni(0x00);

	/* LED */
	outb(P5DDR,0xff);

	/* Switch pull-up */
	outb(P4DDR,0x00);
	outb(P4PCR,0xf0);

	timer_init();
	sio0_init();
	//kbd_init();
	eeprom_init();
	lcd_init();
	lcd_puts(0,0,"Key/Mouse       ");
	lcd_puts(0,1,"   Switcher     ");
	sleep(500);
	lcd_puts(0,0,"Designed by     ");
	lcd_puts(0,1,"  Koji Suzuki   ");
	sleep(500);
	lcd_clear();
	{
		int i;
		char buf[32];
		long t1,t2;
		t1 = systicks;
		for (i=0; i<10000; i++) {
			delay(100);
		}
		t2 = systicks;
		itoa(buf,(int)(t2-t1));
		lcd_puts(0,0,buf);

		t1 = systicks;
		for (i=0; i<25000; i++) {
			nop  ();
		}
		for (i=0; i<25000; i++) {
			nop  ();
		}
		for (i=0; i<25000; i++) {
			nop  ();
		}
		for (i=0; i<25000; i++) {
			nop  ();
		}
		t2 = systicks;
		itoa(buf,(int)(t2-t1));
		lcd_puts(0,1,buf);
		sleep(10000);
	}

	//kbd_send(CMD_RESET);
	{
		char b[10];
		int i,ret;

		for (i=0; i<10; i++) b[i] = 0;

		ret = eeprom_read(0,b,10);
		printx(0,1,ret);
		putc0(' ');
		putc0(' ');
		for (i=0; i<6; i++) printx(0,2,b[i]);

		for (i=0; i<10; i++) b[i]++;


		ret = eeprom_write(0,b,10);
		sleep(5);
		printx(1,1,ret);
		ret = eeprom_read(0,b,10);
		printx(1,1,ret);
		putc1(' ');
		for (i=0; i<6; i++) printx(1,2,b[i]);

	}
	for (i=0; ;i++) {
		if (kbd_data_cnt) {
			s = inh();
			for (i=0; i< kbd_data_cnt; i++) {
				dat[i] = kbd_data[i];
			}
			dat_cnt = kbd_data_cnt;
			kbd_data_cnt = 0;
			eni(s);
			putc0(' ');
			for (j=0; j< dat_cnt; j++) {
				putc0('k');
				printx(0,2,dat[j]>>1);
			}
		}
		if (sio0_data_cnt) {
			s = inh();
			for (i=0; i< sio0_data_cnt; i++) {
				dat[i] = sio0_data[i];
			}
			dat_cnt = sio0_data_cnt;
			sio0_data_cnt = 0;
			eni(s);
			for (j=0; j< dat_cnt; j++) {
				putc0('s');
				printx(0,2,dat[j]);
			}
		}
		if (sio1_data_cnt) {
			s = inh();
			for (i=0; i< sio1_data_cnt; i++) {
				dat[i] = sio1_data[i];
			}
			dat_cnt = sio1_data_cnt;
			sio1_data_cnt = 0;
			eni(s);
			for (j=0; j< dat_cnt; j++) {
				putc0('t');
				printx(0,2,dat[j]);
			}
			if (dat[0] == 'r') {
				kbd_init();
			}
		}
		if ((systicks /500) & 1) {
			orb(P5DR,0x01);
		} else {
			andb(P5DR,~0x01);
		}
		if ( !(inb(P4DR) & 0x10) && (prev4 & 0x10) ) {
#if 0
			extern int kbd_recv_diff;
			putc1('s');
			printx(1,4,kbd_send_cnt);
			putc1('r');
			printx(1,4,kbd_recv_cnt);
			putc1('d');
			printx(1,4,kbd_recv_diff);
#endif
#if 0
			extern int kbd_intr_cnt;
			putc1(' ');
			putc1('i');
			printx(1,4,kbd_intr_cnt);
			putc1('l');
			printx(1,4,(int)last_kbd_modified);
#endif
			extern int kbd_intr_cnt;
			extern int kbd_ov_cnt;
			extern int kbd_to_cnt;
			putc1(' ');
			putc1('i');
			printx(1,2,kbd_intr_cnt);
			putc1('o');
			printx(1,2,kbd_ov_cnt);
			putc1('t');
			printx(1,2,kbd_to_cnt);
			kbd_intr_cnt = 0;
			kbd_ov_cnt = 0;
			kbd_to_cnt = 0;
			
		}
		if ( !(inb(P4DR) & 0x20) && (prev4 & 0x20) ) {
			kbd_send(CMD_SEND_DEV_ID);
		}
		if ( !(inb(P4DR) & 0x40) && (prev4 & 0x40) ) {
			kbd_send(CMD_SEND_DEV_DATA);
		}
		if ( !(inb(P4DR) & 0x80) && (prev4 & 0x80) ) {
			kbd_send(CMD_SEND_DEV_STATUS);
		}
		if (ierror) {
			putc1('e');
			printx(1,4,ierror);
			ierror = 0;
		}
		prev4 = inb(P4DR);
		sleep(10);
	}
}

int sgetch(void)
{
    unsigned char ch;
    while(!(inb(SSR1)&0x40));
    ch=inb(RDR1);
    outb(SSR1,inb(SSR1)& ~0x40);
    return (int)ch;
}

sputs(char *s) {
	while (*s) {
		sputch(*s);
		s++;
	}
}

void sputch(int ch)
{
    revred();
    while(!(inb(SSR1)&0x80));
    outb(TDR1,ch);
    outb(SSR1,inb(SSR1)& ~0x80);
    revred();
}

#pragma interrupt
void int_nmi(void)
{
	ierror |= 0x0100;
}
#pragma interrupt
void int_adi(void)
{
	ierror |= 0x0200;
}

printb(posx,posy,w,x) int x; {
	int i;

	i = 16 - w;
	lcd_locate(posx,posy);
	for (; i<16; i++) {
		lcd_putc( (x & (0x8000>>i))?'1':'0');
	}
}

printx(pos,w,x) int x; {
	int i,y,c;

	i = 4 - w;
	for (; i<4; i++) {
		y = (x >> ((3-i)*4) ) & 0xf;
		c = ( (y > 9)? ( 'A' + y - 10 ): ('0' + y));
		if (pos == 0)
			putc0(c);
		else
			putc1(c);
	}
}

itoa(buf,x) char *buf; int x; {
	int a = 10000;
	int i;

	if (x < 0) {
		*(buf++) = '-';
		x = -x;
	}
	for (i=0; i<5; i++) {
		if ((i ==4) || ((x / a) != 0)) {
			*(buf++) = '0' + ((x/a)%10);
		}
		a /= 10;
	}
	*(buf++) = 0;
}

static char lmes0[17] = "                ";
static char lmes1[17] = "                ";

putc0(x) {
	int i;

	for (i=0; i<15; i++) {
		lmes0[i] = lmes0[i+1];
	}
	lmes0[i] = x;
	lcd_puts(0,0,lmes0);
}

putc1(x) {
	int i;

	for (i=0; i<15; i++) {
		lmes1[i] = lmes1[i+1];
	}
	lmes1[i] = x;
	lcd_puts(0,1,lmes1);
}
